diff -Naur test-for-latech/arch/arm/config.in testqf-for-latech/arch/arm/config.in
--- test-for-latech/arch/arm/config.in	2004-06-11 07:42:31.000000000 -0400
+++ testqf-for-latech/arch/arm/config.in	2004-06-11 07:49:18.000000000 -0400
@@ -654,4 +654,15 @@
 dep_bool '  Kernel low-level debugging functions' CONFIG_DEBUG_LL $CONFIG_DEBUG_KERNEL
 dep_bool '    Kernel low-level debugging messages via footbridge serial port' CONFIG_DEBUG_DC21285_PORT $CONFIG_DEBUG_LL $CONFIG_FOOTBRIDGE
 dep_bool '    Kernel low-level debugging messages via UART2' CONFIG_DEBUG_CLPS711X_UART2 $CONFIG_DEBUG_LL $CONFIG_ARCH_CLPS711X
+
+#dep_bool 'modular DWCS scheduler' CONFIG_DWCS $CONFIG_PROC_FS
+#dep_bool '    DFS Support' CONFIG_DWCS_DFS $CONFIG_DWCS
+
+bool 'Quality of Service Support (Q-Fabric)' CONFIG_QFABRIC
+if [ "$CONFIG_QFABRIC" = "y" ]
+	define_bool CONFIG_DWCS
+	define_bool CONFIG_DWCS_DFS
+	define_bool CONFIG_PROC_FS
+fi	
+
 endmenu
diff -Naur test-for-latech/arch/arm/kernel/calls.S testqf-for-latech/arch/arm/kernel/calls.S
--- test-for-latech/arch/arm/kernel/calls.S	2004-06-11 07:42:31.000000000 -0400
+++ testqf-for-latech/arch/arm/kernel/calls.S	2004-06-11 07:49:18.000000000 -0400
@@ -253,6 +253,28 @@
 		.long	SYMBOL_NAME(sys_ni_syscall) /* sys_lremovexattr */
 		.long	SYMBOL_NAME(sys_ni_syscall) /* sys_fremovexattr */
 		.long	SYMBOL_NAME(sys_tkill)
+   		.long SYMBOL_NAME(sys_load_scheduler)	
+   		.long SYMBOL_NAME(sys_unload_scheduler)	
+	   	.long SYMBOL_NAME(sys_DWCS_scheduler)	
+		.long SYMBOL_NAME(sys_update_utilization)
+		.long SYMBOL_NAME(sys_admission_control)
+		.long SYMBOL_NAME(sys_start_ecalls)
+		.long SYMBOL_NAME(sys_end_ecalls)
+		.long SYMBOL_NAME(sys_register_ecall)
+		.long SYMBOL_NAME(sys_do_downcall)
+		.long SYMBOL_NAME(sys_run_event_handler)
+		.long SYMBOL_NAME(sys_upcall_scheduler)
+		.long SYMBOL_NAME(sys_wake_up_ecalls)
+		.long SYMBOL_NAME(sys_download_code)
+		.long SYMBOL_NAME(sys_kecho_load)
+		.long SYMBOL_NAME(sys_KECho_syscall_echo)
+		.long SYMBOL_NAME(sys_KECho_syscall_cm)
+		.long SYMBOL_NAME(sys_KECho_syscall_cg)
+		.long SYMBOL_NAME(sys_KECho_syscall_atl)
+		.long SYMBOL_NAME(sys_KECho_sw_callback)
+		.long SYMBOL_NAME(sys_getsyscalls)
+		.long SYMBOL_NAME(sys_qos_configure)
+		.long SYMBOL_NAME(sys_change_clock)
 		/*
 		 * Please check 2.5 _before_ adding calls here,
 		 * and copy changes to rmk@arm.linux.org.uk.  Thanks.
diff -Naur test-for-latech/arch/arm/kernel/init_task.c testqf-for-latech/arch/arm/kernel/init_task.c
--- test-for-latech/arch/arm/kernel/init_task.c	2004-06-11 07:42:31.000000000 -0400
+++ testqf-for-latech/arch/arm/kernel/init_task.c	2004-06-11 07:49:18.000000000 -0400
@@ -13,6 +13,9 @@
 static struct files_struct init_files = INIT_FILES;
 static struct signal_struct init_signals = INIT_SIGNALS;
 struct mm_struct init_mm = INIT_MM(init_mm);
+#ifdef CONFIG_DWCS
+struct dwcs_struct init_dwcs = INIT_DWCS; /* --FS-- Check linux/sched.h */
+#endif
 
 /*
  * Initial task structure.
diff -Naur test-for-latech/arch/arm/kernel/process.c testqf-for-latech/arch/arm/kernel/process.c
--- test-for-latech/arch/arm/kernel/process.c	2004-06-11 07:42:31.000000000 -0400
+++ testqf-for-latech/arch/arm/kernel/process.c	2004-06-11 07:49:18.000000000 -0400
@@ -369,6 +369,9 @@
 pid_t kernel_thread(int (*fn)(void *), void *arg, unsigned long flags)
 {
 	pid_t __ret;
+#ifdef CONFIG_QFABRIC
+	struct task_struct *p;
+#endif
 
 	__asm__ __volatile__(
 	"orr	r0, %1, %2	@ kernel_thread sys_clone
@@ -385,6 +388,12 @@
         : "=r" (__ret)
         : "Ir" (flags), "I" (CLONE_VM), "r" (fn), "r" (arg)
 	: "r0", "r1", "lr");
+#ifdef CONFIG_QFABRIC
+#ifdef CONFIG_X86
+	p = find_task_by_pid(retval);
+	p->kthread = 1;
+#endif
+#endif
 	return __ret;
 }
 
diff -Naur test-for-latech/arch/i386/config.in testqf-for-latech/arch/i386/config.in
--- test-for-latech/arch/i386/config.in	2004-06-11 07:42:22.000000000 -0400
+++ testqf-for-latech/arch/i386/config.in	2004-06-11 07:49:01.000000000 -0400
@@ -425,4 +425,12 @@
    bool '  Compile the kernel with frame pointers' CONFIG_FRAME_POINTER
 fi
 
+#dep_bool 'modular DWCS scheduler' CONFIG_DWCS $CONFIG_PROC_FS
+
+bool 'Quality of Service Support (Q-Fabric)' CONFIG_QFABRIC
+if [ "$CONFIG_QFABRIC" = "y" ]; then
+   define_bool CONFIG_DWCS y
+   define_bool CONFIG_PROC_FS y
+fi
+
 endmenu
diff -Naur test-for-latech/arch/i386/kernel/entry.S testqf-for-latech/arch/i386/kernel/entry.S
--- test-for-latech/arch/i386/kernel/entry.S	2004-06-11 07:42:23.000000000 -0400
+++ testqf-for-latech/arch/i386/kernel/entry.S	2004-06-11 07:49:01.000000000 -0400
@@ -202,6 +202,9 @@
 	call *SYMBOL_NAME(sys_call_table)(,%eax,4)
 	movl %eax,EAX(%esp)		# save the return value
 ENTRY(ret_from_sys_call)
+#ifdef CONFIG_QFABRIC
+	call SYMBOL_NAME(inc_syscall_counter)
+#endif
 	cli				# need_resched and signals atomic test
 	cmpl $0,need_resched(%ebx)
 	jne reschedule
@@ -259,6 +262,85 @@
 	call SYMBOL_NAME(schedule)    # test
 	jmp ret_from_sys_call
 
+#ifdef CONFIG_QFABRIC
+ENTRY(fast_system_call)
+	pushl %eax			# save orig_eax
+	SAVE_ALL
+	call *SYMBOL_NAME(fast_sys_call_table)(,%eax,4)
+	movl %eax,EAX(%esp)		# save the return value
+	cmpl $0,%eax
+	jnz handle_return_value
+	RESTORE_ALL
+
+handle_return_value:
+	cmpl $-1,%eax
+	jz not_installed
+	testl $8,%eax
+	jnz do_slow_call
+	GET_CURRENT(%ebx)
+	testl $1,%eax
+	jnz do_bh
+cont1:
+	testl $2,%eax
+	jnz do_reschedule
+cont2:
+	testl $4,%eax
+	jnz handle_signal
+cont3:
+	RESTORE_ALL
+
+not_installed:
+	RESTORE_ALL
+
+do_slow_call:
+	GET_CURRENT(%ebx)
+	testb $0x20,flags(%ebx)		# PF_TRACESYS
+	jne tracesys
+	movl ORIG_EAX(%esp),%eax
+	call *SYMBOL_NAME(sys_call_table)(,%eax,4)
+	movl %eax,EAX(%esp)		# save the return value
+	ALIGN
+	.globl ret_from_sys_call
+	.globl ret_from_intr
+
+do_bh:
+#ifdef CONFIG_SMP
+	movl processor(%ebx),%eax
+	shll $CONFIG_X86_L1_CACHE_SHIFT,%eax
+	movl SYMBOL_NAME(irq_stat)(,%eax),%ecx		# softirq_active
+	testl SYMBOL_NAME(irq_stat)+4(,%eax),%ecx	# softirq_mask
+#else
+	movl SYMBOL_NAME(irq_stat),%ecx		# softirq_active
+	testl SYMBOL_NAME(irq_stat)+4,%ecx	# softirq_mask
+#endif
+        jne do_handle_bh
+	jmp cont1
+
+do_handle_bh:
+	call SYMBOL_NAME(do_softirq)
+	jmp cont1
+
+do_reschedule:
+	movl EFLAGS(%esp),%eax
+	movb CS(%esp),%al
+	testl $(VM_MASK | 3),%eax
+	je cont2
+	cmpl $0,need_resched(%ebx)
+	je cont2
+	call SYMBOL_NAME(schedule)
+	jmp ret_from_sys_call
+
+handle_signal:
+	cmpl $0,sigpending(%ebx)
+	je cont3
+	testl $(VM_MASK),EFLAGS(%esp)
+	movl %esp,%eax
+	jne v86_signal_return
+	xorl %edx,%edx
+	call SYMBOL_NAME(do_signal)
+	jmp cont3
+#endif
+
 ENTRY(divide_error)
 	pushl $0		# no error code
 	pushl $ SYMBOL_NAME(do_divide_error)
@@ -639,7 +721,300 @@
 	.long SYMBOL_NAME(sys_ni_syscall)	/* 240 reserved for futex */
 	.long SYMBOL_NAME(sys_ni_syscall)	/* reserved for sched_setaffinity */
 	.long SYMBOL_NAME(sys_ni_syscall)	/* reserved for sched_getaffinity */
-
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+   	.long SYMBOL_NAME(sys_update_utilization)
+    	.long SYMBOL_NAME(sys_admission_control)
+   	.long SYMBOL_NAME(sys_start_ecalls)	
+    	.long SYMBOL_NAME(sys_end_ecalls)	
+    	.long SYMBOL_NAME(sys_register_ecall)	
+    	.long SYMBOL_NAME(sys_do_downcall)	
+    	.long SYMBOL_NAME(sys_run_event_handler)
+    	.long SYMBOL_NAME(sys_upcall_scheduler)
+    	.long SYMBOL_NAME(sys_wake_up_ecalls)	
+    	.long SYMBOL_NAME(sys_download_code)	
+  	.long SYMBOL_NAME(sys_kecho_load)	
+    	.long SYMBOL_NAME(sys_KECho_syscall_echo)
+    	.long SYMBOL_NAME(sys_KECho_syscall_cm)	
+    	.long SYMBOL_NAME(sys_KECho_syscall_cg)	
+    	.long SYMBOL_NAME(sys_KECho_syscall_atl)
+    	.long SYMBOL_NAME(sys_KECho_sw_callback)
+    	.long SYMBOL_NAME(sys_getsyscalls)      
+ 	.long SYMBOL_NAME(sys_qos_configure) 
+ 	.long SYMBOL_NAME(sys_change_clock) 
+#ifdef CONFIG_NET_QSOCKET
+ 	.long SYMBOL_NAME(sys_qsocketcall)	
+#endif
+ 
 	.rept NR_syscalls-(.-sys_call_table)/4
 		.long SYMBOL_NAME(sys_ni_syscall)
 	.endr
+
+.data
+ENTRY(fast_sys_call_table)
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 0 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_fast_read)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 5 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 10 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 15 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 20 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 25 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 30 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 35 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+   	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 40 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 45 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 50 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 55 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 60 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 65 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 70 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 75 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 80 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 85 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 90 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 95 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 100 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 105 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 110 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+   	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 115 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 120 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 125 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 130 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 135 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 140 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 145 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 150 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 155 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 160 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 165 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 170 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 175 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 180 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 185 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 190 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 195 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 200 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 205 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 210 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 215 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 220 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 225 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	/* 230 */
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_fast_do_downcall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+   	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_ni_syscall)	
+    	.long SYMBOL_NAME(sys_fast_KECho_syscall_echo)	
+    	.long SYMBOL_NAME(sys_fast_KECho_syscall_cm)	
+    	.long SYMBOL_NAME(sys_fast_KECho_syscall_cg)	
+    	.long SYMBOL_NAME(sys_fast_KECho_syscall_atl)	
+    
+ 	.rept NR_syscalls-(.-fast_sys_call_table)/4
+ 		.long SYMBOL_NAME(sys_ni_syscall)
+ 	.endr
diff -Naur test-for-latech/arch/i386/kernel/i8259.c testqf-for-latech/arch/i386/kernel/i8259.c
--- test-for-latech/arch/i386/kernel/i8259.c	2004-06-11 07:42:23.000000000 -0400
+++ testqf-for-latech/arch/i386/kernel/i8259.c	2004-06-11 07:49:01.000000000 -0400
@@ -456,8 +456,14 @@
 	 */
 	for (i = 0; i < NR_IRQS; i++) {
 		int vector = FIRST_EXTERNAL_VECTOR + i;
+#ifdef CONFIG_QFABRIC
+		if ((vector != SYSCALL_VECTOR) && 
+		  (vector != FAST_SYSCALL_VECTOR))
+		    	set_intr_gate(vector, interrupt[i]);
+#else
 		if (vector != SYSCALL_VECTOR) 
 			set_intr_gate(vector, interrupt[i]);
+#endif
 	}
 
 #ifdef CONFIG_SMP
diff -Naur test-for-latech/arch/i386/kernel/init_task.c testqf-for-latech/arch/i386/kernel/init_task.c
--- test-for-latech/arch/i386/kernel/init_task.c	2004-06-11 07:42:23.000000000 -0400
+++ testqf-for-latech/arch/i386/kernel/init_task.c	2004-06-11 07:49:01.000000000 -0400
@@ -10,6 +10,9 @@
 static struct files_struct init_files = INIT_FILES;
 static struct signal_struct init_signals = INIT_SIGNALS;
 struct mm_struct init_mm = INIT_MM(init_mm);
+#ifdef CONFIG_DWCS
+struct dwcs_struct init_dwcs = INIT_DWCS; /* --RW-- Check linux/sched.h */
+#endif
 
 /*
  * Initial task structure.
diff -Naur test-for-latech/arch/i386/kernel/process.c testqf-for-latech/arch/i386/kernel/process.c
--- test-for-latech/arch/i386/kernel/process.c	2004-06-11 07:42:23.000000000 -0400
+++ testqf-for-latech/arch/i386/kernel/process.c	2004-06-11 07:49:01.000000000 -0400
@@ -488,6 +488,9 @@
 int kernel_thread(int (*fn)(void *), void * arg, unsigned long flags)
 {
 	long retval, d0;
+#ifdef CONFIG_QFABRIC
+	struct task_struct *p;
+#endif
 
 	__asm__ __volatile__(
 		"movl %%esp,%%esi\n\t"
@@ -508,6 +511,10 @@
 		 "r" (arg), "r" (fn),
 		 "b" (flags | CLONE_VM)
 		: "memory");
+#ifdef CONFIG_QFABRIC
+	p = find_task_by_pid(retval);
+	p->kthread = 1;
+#endif
 	return retval;
 }
 
diff -Naur test-for-latech/arch/i386/kernel/ptrace.c testqf-for-latech/arch/i386/kernel/ptrace.c
--- test-for-latech/arch/i386/kernel/ptrace.c	2004-06-11 07:42:23.000000000 -0400
+++ testqf-for-latech/arch/i386/kernel/ptrace.c	2004-06-11 07:49:01.000000000 -0400
@@ -452,3 +452,11 @@
 		current->exit_code = 0;
 	}
 }
+
+#ifdef CONFIG_QFABRIC
+asmlinkage void inc_syscall_counter()
+{
+	current->syscall_counter++;
+}
+EXPORT_SYMBOL(inc_syscall_counter);
+#endif
diff -Naur test-for-latech/arch/i386/kernel/traps.c testqf-for-latech/arch/i386/kernel/traps.c
--- test-for-latech/arch/i386/kernel/traps.c	2004-06-11 07:42:22.000000000 -0400
+++ testqf-for-latech/arch/i386/kernel/traps.c	2004-06-11 07:49:01.000000000 -0400
@@ -51,6 +51,9 @@
 #include <linux/module.h>
 
 asmlinkage int system_call(void);
+#ifdef CONFIG_QFABRIC
+asmlinkage int fast_system_call(void);
+#endif
 asmlinkage void lcall7(void);
 asmlinkage void lcall27(void);
 
@@ -985,6 +988,9 @@
 	set_trap_gate(19,&simd_coprocessor_error);
 
 	set_system_gate(SYSCALL_VECTOR,&system_call);
+#ifdef CONFIG_QFABRIC
+	set_system_gate(FAST_SYSCALL_VECTOR,&fast_system_call);
+#endif
 
 	/*
 	 * default LDT is a single-entry callgate to lcall7 for iBCS
diff -Naur test-for-latech/arch/i386/lib/usercopy.c testqf-for-latech/arch/i386/lib/usercopy.c
--- test-for-latech/arch/i386/lib/usercopy.c	2004-06-11 07:42:22.000000000 -0400
+++ testqf-for-latech/arch/i386/lib/usercopy.c	2004-06-11 07:49:01.000000000 -0400
@@ -27,6 +27,12 @@
 unsigned long
 __generic_copy_from_user(void *to, const void *from, unsigned long n)
 {
+#ifdef CONFIG_QFABRIC
+	if (current->uaccess_flag == 1) {
+		memcpy(to, from, n);
+		return 0;
+	}
+#endif
 	if (access_ok(VERIFY_READ, from, n))
 	{
 		if(n<512)
@@ -53,6 +59,12 @@
 unsigned long
 __generic_copy_from_user(void *to, const void *from, unsigned long n)
 {
+#ifdef CONFIG_QFABRIC
+	if (current->uaccess_flag == 1) {
+		memcpy(to, from, n);
+		return 0;
+	}
+#endif
 	prefetchw(to);
 	if (access_ok(VERIFY_READ, from, n))
 		__copy_user_zeroing(to,from,n);
diff -Naur test-for-latech/Documentation/Configure.help testqf-for-latech/Documentation/Configure.help
--- test-for-latech/Documentation/Configure.help	2004-06-11 07:42:36.000000000 -0400
+++ testqf-for-latech/Documentation/Configure.help	2004-06-11 07:49:26.000000000 -0400
@@ -20527,6 +20527,36 @@
 
   "Area6" will work for most boards. For ADX, select "Area5".
 
+#modular DWCS process scheduler
+#CONFIG_DWCS
+#  This option includes a kernel loadable module dwcs.o which implements
+#  a Dynamic Window-Constrained Scheduler instead of the regular Linux
+#  scheduler. Loading the module is not enough, you have to switch 
+#  scheduling to the new scheduler.
+
+#  To find out more about the scheduler, or to find out more about how
+#  to use it visit: http://www.cc.gatech.edu/~west/dwcs.html
+
+#  This scheduler is for hacking purposes only, it seems to be stable on
+#  uniprocessor machines, but not on SMP boxes. You've been warned. This
+#  is still very experimental code, play with it _only_ if you know what
+#  you are doing.
+
+#DWCS /proc interface
+#CONFIG_PROC_DWCS
+#  This option enables a pseudo file /proc/dwcs reading which will give
+#  you a snapshot of the current operating parameters of the DWCS 
+#  scheduler. The file exists only when the scheduler is loaded.
+
+Quality of Service Support (Q-Fabric)
+CONFIG_QFABRIC
+  If you say Y here, Artemis-enabled kernel extensions can be used by 
+  applications. Artemis is a QoS infrastructure based on a distributed
+  event notification mechanism (called KECho). Saying Y here only adds
+  the necessary modifications to the kernel to support Artemis. The 
+  actual Artemis modules are not part of the kernel, but are made 
+  available in a software package available at http://www.cc.gatech.edu/~chris.
+
 #
 # m68k-specific kernel options
 # Documented by Chris Lawrence <mailto:quango@themall.net> et al.
diff -Naur test-for-latech/fs/read_write.c testqf-for-latech/fs/read_write.c
--- test-for-latech/fs/read_write.c	2004-06-11 07:39:57.000000000 -0400
+++ testqf-for-latech/fs/read_write.c	2004-06-11 07:47:19.000000000 -0400
@@ -425,3 +425,9 @@
 bad_file:
 	return ret;
 }
+
+asmlinkage int sys_fast_read(int fd,
+	void *buffer, int len)
+{
+        return 0;
+}
diff -Naur test-for-latech/include/asm-arm/current.h testqf-for-latech/include/asm-arm/current.h
--- test-for-latech/include/asm-arm/current.h	2004-06-11 07:40:29.000000000 -0400
+++ testqf-for-latech/include/asm-arm/current.h	2004-06-11 07:47:34.000000000 -0400
@@ -1,14 +1,32 @@
 #ifndef _ASMARM_CURRENT_H
 #define _ASMARM_CURRENT_H
 
+#ifdef CONFIG_QFABRIC
+extern int ECalls_current_flag;
+extern struct task_struct *ECalls_current;
+#endif
+
 static inline struct task_struct *get_current(void) __attribute__ (( __const__ ));
 
-static inline struct task_struct *get_current(void)
+static inline struct task_struct *original_get_current(void) __attribute__ (( __const__ ));
+
+static inline struct task_struct *original_get_current(void)
 {
 	register unsigned long sp asm ("sp");
 	return (struct task_struct *)(sp & ~0x1fff);
 }
 
+#define original_current original_get_current()
+
+static inline struct task_struct *get_current(void)
+{
+#ifdef CONFIG_QFABRIC
+	if (ECalls_current_flag == 1)
+		return ECalls_current;
+#endif
+	return original_get_current();
+}
+
 #define current (get_current())
 
 #endif /* _ASMARM_CURRENT_H */
diff -Naur test-for-latech/include/asm-arm/errno.h testqf-for-latech/include/asm-arm/errno.h
--- test-for-latech/include/asm-arm/errno.h	2004-06-11 07:40:29.000000000 -0400
+++ testqf-for-latech/include/asm-arm/errno.h	2004-06-11 07:47:34.000000000 -0400
@@ -129,4 +129,8 @@
 #define	ENOMEDIUM	123	/* No medium found */
 #define	EMEDIUMTYPE	124	/* Wrong medium type */
 
+#ifdef CONFIG_QFABRIC
+#define EADMISSION	125	/* Task admission denied. */
+#endif
+
 #endif
diff -Naur test-for-latech/include/asm-arm/socket.h testqf-for-latech/include/asm-arm/socket.h
--- test-for-latech/include/asm-arm/socket.h	2004-06-11 07:40:29.000000000 -0400
+++ testqf-for-latech/include/asm-arm/socket.h	2004-06-11 07:47:34.000000000 -0400
@@ -45,6 +45,11 @@
 
 #define SO_ACCEPTCONN		30
 
+#ifdef CONFIG_QFABRIC
+#define SO_QOS_PRIORITY		1000
+#define SO_QOS_DEADLINE		1001
+#endif
+
 /* Nast libc5 fixup - bletch */
 #if defined(__KERNEL__)
 /* Socket types. */
diff -Naur test-for-latech/include/asm-arm/uaccess.h testqf-for-latech/include/asm-arm/uaccess.h
--- test-for-latech/include/asm-arm/uaccess.h	2004-06-11 07:40:29.000000000 -0400
+++ testqf-for-latech/include/asm-arm/uaccess.h	2004-06-11 07:47:34.000000000 -0400
@@ -23,6 +23,11 @@
  * on our cache or tlb entries.
  */
 
+#ifdef CONFIG_QFABRIC
+extern mm_segment_t kernel_get_fs(void);
+extern int kernel_access_ok(int type, const void *addr, size_t size);
+#endif
+
 struct exception_table_entry
 {
 	unsigned long insn, fixup;
@@ -32,12 +37,28 @@
 extern unsigned long search_exception_table(unsigned long);
 
 #define get_ds()	(KERNEL_DS)
+#ifdef CONFIG_QFABRIC
+#ifdef MODULE
+#define get_fs()	(current->addr_limit)
+#else
+#define get_fs()	kernel_get_fs()
+#endif
+#else
 #define get_fs()	(current->addr_limit)
+#endif
 #define segment_eq(a,b)	((a) == (b))
 
 #include <asm/proc/uaccess.h>
 
+#ifdef CONFIG_QFABRIC
+#ifdef MODULE
+#define access_ok(type,addr,size)	(__range_ok(addr,size) == 0)
+#else
+#define access_ok(type,addr,size)	kernel_access_ok(type,addr,size)
+#endif
+#else
 #define access_ok(type,addr,size)	(__range_ok(addr,size) == 0)
+#endif
 
 static inline int verify_area(int type, const void * addr, unsigned long size)
 {
@@ -143,6 +164,12 @@
 
 static __inline__ unsigned long copy_from_user(void *to, const void *from, unsigned long n)
 {
+#ifdef CONFIG_QFABRIC
+	if (current->uaccess_flag == 1) {
+		memcpy(to, from, n);
+		return 0;
+	}
+#endif
 	if (access_ok(VERIFY_READ, from, n))
 		__do_copy_from_user(to, from, n);
 	else /* security hole - plug it */
@@ -152,12 +179,24 @@
 
 static __inline__ unsigned long __copy_from_user(void *to, const void *from, unsigned long n)
 {
+#ifdef CONFIG_QFABRIC
+	if (current->uaccess_flag == 1) {
+		memcpy(to, from, n);
+		return 0;
+	}
+#endif
 	__do_copy_from_user(to, from, n);
 	return n;
 }
 
 static __inline__ unsigned long copy_to_user(void *to, const void *from, unsigned long n)
 {
+#ifdef CONFIG_QFABRIC
+	if (current->uaccess_flag == 1) {
+		memcpy(to, from, n);
+		return 0;
+	}
+#endif
 	if (access_ok(VERIFY_WRITE, to, n))
 		__do_copy_to_user(to, from, n);
 	return n;
@@ -165,6 +204,12 @@
 
 static __inline__ unsigned long __copy_to_user(void *to, const void *from, unsigned long n)
 {
+#ifdef CONFIG_QFABRIC
+	if (current->uaccess_flag == 1) {
+		memcpy(to, from, n);
+		return 0;
+	}
+#endif
 	__do_copy_to_user(to, from, n);
 	return n;
 }
